#include "launcher.h"

#include <QDebug>
#include <QObject>
#include <QWidget>
#include <QDir>
#include <QCoreApplication>
#include <QString>
#include <QList>
#include <qjsonobject.h>

#include "profile_handler/forge1_12_2.h"
#include "../ui/mainwindow.h"
#include "../../resources/ui_mainwindow.h"


Launcher::Launcher(QObject *mainwindow) : QObject(mainwindow), process(new QProcess(this)), mainwindow(mainwindow), get_args(new forge1_12_2()) {
}


Launcher::~Launcher() {
    delete process;
}


void Launcher::startProcess(QString &username, QString &uuid, QString &access_token) {
	// Подготовка параметров запуска
    MainWindow *mainWindow = qobject_cast<MainWindow *>(mainwindow);
    QString selected_profile = mainWindow->ui->selected_profile->currentText();
    QDir exe_dir(QCoreApplication::applicationDirPath());
    client_dir = exe_dir.absolutePath() + "/" + selected_profile;
    json_settings = mainWindow->settings->loadFromJson(selected_profile);
    java_path = json_settings["java_path"].toString();
    RAM = json_settings["RAM"].toString();
    garbarge_collector = json_settings["garbarge_collector"].toString();

	//
	// Выбор профиля
	//
    if (selected_profile == "CyberExtrieme") {
		arguments = get_args->getCrossPlatformArgs(RAM, username, uuid, access_token, garbarge_collector);
        java_path = java_path.isEmpty() ? 
            exe_dir.absolutePath() + "/java/zulu8.84.0.15-ca-jre8.0.442-linux_x64/bin/java" : java_path;
        RAM = RAM.isEmpty() ? "4096M" : RAM;
        garbarge_collector = garbarge_collector.isEmpty() ? "default_collector" : garbarge_collector;
    }

	// Запуск процесса
    process->setWorkingDirectory(client_dir);
    process->start(java_path, arguments);

    if (!process->waitForStarted()) {
        qDebug() << "Failed to start process";
        qDebug() << process->errorString();
        return;
    }


	// Скрытие лаунчера
	connect(process,
		QOverload<int, QProcess::ExitStatus>::of(&QProcess::finished),
		[mainWindow](int, QProcess::ExitStatus) { mainWindow->show(); });
	mainWindow->hide();
    qDebug() << "Process started successfully";
}
